/*-
 * Copyright 2008 Jason Harmening
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __CX88_AUDIO_REGS_H__
#define __CX88_AUDIO_REGS_H__

#define AUDIO_REG_IN_PTR1              0x300090
#define AUDIO_REG_OUT_PTR1             0x300094

#define AUDIO_REG_IN_PTR2              0x3000D0
#define AUDIO_REG_OUT_PTR2             0x3000D4

#define AUDIO_REG_IN_CNT1              0x300110
#define AUDIO_REG_OUT_CNT1             0x300114

#define AUDIO_REG_IN_CNT2              0x300150
#define AUDIO_REG_OUT_CNT2             0x300154

#define AUDIO_REG_INIT                 0x320100
#define AUDIO_INIT_BTSC                1
#define AUDIO_INIT_EIAJ                2
#define AUDIO_INIT_A2                  4
#define AUDIO_INIT_BTSC_SAP            8
#define AUDIO_INIT_NICAM               16
#define AUDIO_INIT_FM_RADIO            32

#define AUDIO_REG_INIT_LOAD            0x320104

#define AUDIO_REG_SOFT_RESET           0x320108

#define AUDIO_REG_I2SINPUT             0x320120
#define I2SINPUT_DISABLE_AUTOBAUD      (1 << 2)
#define I2SINPUT_SONY_SPEC             (1 << 1)
#define I2SINPUT_MASTER                (1 << 0)

#define AUDIO_REG_I2SOUTPUT            0x320128
#define I2SOUTPUT_MUTE                 (1 << 1)
#define I2SOUTPUT_SONY_SPEC            (1 << 0)

#define AUDIO_REG_AGC_HYST             0x320134
#define AUDIO_REG_AGC_GAIN             0x320138
#define AUDIO_REG_AGC_DEF              0x32013C
#define AUDIO_REG_IIR1_0_SEL           0x320150
#define AUDIO_REG_IIR1_0_SHIFT         0x320154
#define AUDIO_REG_IIR1_1_SEL           0x320158
#define AUDIO_REG_IIR1_1_SHIFT         0x32015C
#define AUDIO_REG_IIR1_2_SEL           0x320160
#define AUDIO_REG_IIR1_2_SHIFT         0x320164
#define AUDIO_REG_IIR1_3_SEL           0x320168
#define AUDIO_REG_IIR1_3_SHIFT         0x32016C
#define AUDIO_REG_IIR1_4_SEL           0x320170
#define AUDIO_REG_IIR1_4_SHIFT         0x32017C
#define AUDIO_REG_IIR1_5_SEL           0x320180
#define AUDIO_REG_IIR1_5_SHIFT         0x320184
#define AUDIO_REG_IIR2_0_SEL           0x320190
#define AUDIO_REG_IIR2_0_SHIFT         0x320194
#define AUDIO_REG_IIR2_1_SEL           0x320198
#define AUDIO_REG_IIR2_1_SHIFT         0x32019C
#define AUDIO_REG_IIR2_2_SEL           0x3201A0
#define AUDIO_REG_IIR2_2_SHIFT         0x3201A4
#define AUDIO_REG_IIR2_3_SEL           0x3201A8
#define AUDIO_REG_IIR2_3_SHIFT         0x3201AC
#define AUDIO_REG_IIR3_0_SEL           0x3201C0
#define AUDIO_REG_IIR3_0_SHIFT         0x3201C4
#define AUDIO_REG_IIR3_1_SEL           0x3201C8
#define AUDIO_REG_IIR3_1_SHIFT         0x3201CC
#define AUDIO_REG_IIR3_2_SEL           0x3201D0
#define AUDIO_REG_IIR3_2_SHIFT         0x3201D4
#define AUDIO_REG_IIR4_0_SEL           0x3201E0
#define AUDIO_REG_IIR4_0_SHIFT         0x3201E4
#define AUDIO_REG_IIR4_1_SEL           0x3201E8
#define AUDIO_REG_IIR4_1_SHIFT         0x3201EC
#define AUDIO_REG_IIR4_2_SEL           0x3201F0
#define AUDIO_REG_IIR4_2_SHIFT         0x3201F4
#define AUDIO_REG_IIR4_0_CA0           0x320200
#define AUDIO_REG_IIR4_0_CA1           0x320204
#define AUDIO_REG_IIR4_0_CA2           0x320208
#define AUDIO_REG_IIR4_0_CB0           0x32020C
#define AUDIO_REG_IIR4_0_CB1           0x320210
#define AUDIO_REG_IIR4_1_CA0           0x320214
#define AUDIO_REG_IIR4_1_CA1           0x320218
#define AUDIO_REG_IIR4_1_CA2           0x32021C
#define AUDIO_REG_IIR4_1_CB0           0x320220
#define AUDIO_REG_IIR4_1_CB1           0x320224
#define AUDIO_REG_IIR4_2_CA0           0x320228
#define AUDIO_REG_IIR4_2_CA1           0x32022C
#define AUDIO_REG_IIR4_2_CA2           0x320230
#define AUDIO_REG_IIR4_2_CB0           0x320234
#define AUDIO_REG_IIR4_2_CB1           0x320238
#define AUDIO_REG_HP_MD_IIR4_1         0x320250
#define AUDIO_REG_HP_PROG_IIR4_1       0x320254
#define AUDIO_REG_FM_MODE_ENABLE       0x320258
#define AUDIO_REG_POLY0_DDS_CONSTANT   0x320270
#define AUDIO_REG_DN0_FREQ             0x320274
#define AUDIO_REG_DN1_FREQ             0x320278
#define AUDIO_REG_DN1_FREQ_SHIFT       0x32027C
#define AUDIO_REG_DN1_AFC              0x320280
#define AUDIO_REG_DN1_SRC_SEL          0x320284
#define AUDIO_REG_DN1_SHFT             0x320288
#define AUDIO_REG_DN2_FREQ             0x32028C
#define AUDIO_REG_DN2_FREQ_SHIFT       0x320290
#define AUDIO_REG_DN2_AFC              0x320294
#define AUDIO_REG_DN2_SRC_SEL          0x320298
#define AUDIO_REG_DN2_SHFT             0x32029C
#define AUDIO_REG_CRDC0_SRC_SEL        0x320300
#define AUDIO_REG_CRDC0_SHIFT          0x320304
#define AUDIO_REG_CORDIC_SHIFT_0       0x320308
#define AUDIO_REG_CRDC1_SRC_SEL        0x32030C
#define AUDIO_REG_CRDC1_SHIFT          0x320310
#define AUDIO_REG_CORDIC_SHIFT_1       0x320314
#define AUDIO_REG_DCOC_0_SRC           0x320320
#define AUDIO_REG_DCOC0_SHIFT          0x320324
#define AUDIO_REG_DCOC_0_SHIFT_IN0     0x320328
#define AUDIO_REG_DCOC_0_SHIFT_IN1     0x32032C
#define AUDIO_REG_DCOC_1_SRC           0x320330
#define AUDIO_REG_DCOC1_SHIFT          0x320334
#define AUDIO_REG_DCOC_1_SHIFT_IN0     0x320338
#define AUDIO_REG_DCOC_1_SHIFT_IN1     0x32033C
#define AUDIO_REG_DCOC_2_SRC           0x320340
#define AUDIO_REG_DCOC2_SHIFT          0x320344
#define AUDIO_REG_DCOC_2_SHIFT_IN0     0x320348
#define AUDIO_REG_DCOC_2_SHIFT_IN1     0x32034C
#define AUDIO_REG_DCOC_PASS_IN         0x320350
#define AUDIO_REG_PDET_SRC             0x320370
#define AUDIO_REG_PDET_SHIFT           0x320374
#define AUDIO_REG_PILOT_BQD_1_K0       0x320380
#define AUDIO_REG_PILOT_BQD_1_K1       0x320384
#define AUDIO_REG_PILOT_BQD_1_K2       0x320388
#define AUDIO_REG_PILOT_BQD_1_K3       0x32038C
#define AUDIO_REG_PILOT_BQD_1_K4       0x320390
#define AUDIO_REG_PILOT_BQD_2_K0       0x320394
#define AUDIO_REG_PILOT_BQD_2_K1       0x320398
#define AUDIO_REG_PILOT_BQD_2_K2       0x32039C
#define AUDIO_REG_PILOT_BQD_2_K3       0x3203A0
#define AUDIO_REG_PILOT_BQD_2_K4       0x3203A4
#define AUDIO_REG_THR_FR               0x3203C0
#define AUDIO_REG_X_PROG               0x3203C4
#define AUDIO_REG_Y_PROG               0x3203C8
#define AUDIO_REG_HARMONIC_MULT        0x3203CC
#define AUDIO_REG_C1_UP_THR            0x3203D0
#define AUDIO_REG_C1_LO_THR            0x3203D4
#define AUDIO_REG_C2_UP_THR            0x3203D8
#define AUDIO_REG_C2_LO_THR            0x3203DC
#define AUDIO_REG_PLL_EN               0x320400
#define AUDIO_REG_PLL_SRC              0x320404
#define AUDIO_REG_PLL_SHIFT            0x320408
#define AUDIO_REG_PLL_IF_SEL           0x32040C
#define AUDIO_REG_PLL_IF_SHIFT         0x320410
#define AUDIO_REG_BIQUAD_PLL_K0        0x320414
#define AUDIO_REG_BIQUAD_PLL_K1        0x320418
#define AUDIO_REG_BIQUAD_PLL_K2        0x32041C
#define AUDIO_REG_BIQUAD_PLL_K3        0x320420
#define AUDIO_REG_BIQUAD_PLL_K4        0x320424
#define AUDIO_REG_DEEMPH0_SRC_SEL      0x320440
#define AUDIO_REG_DEEMPH0_SHIFT        0x320444
#define AUDIO_REG_DEEMPH0_G0           0x320448
#define AUDIO_REG_DEEMPH0_A0           0x32044C
#define AUDIO_REG_DEEMPH0_B0           0x320450
#define AUDIO_REG_DEEMPH0_A1           0x320454
#define AUDIO_REG_DEEMPH0_B1           0x320458
#define AUDIO_REG_DEEMPH1_SRC_SEL      0x32045C
#define AUDIO_REG_DEEMPH1_SHIFT        0x320460
#define AUDIO_REG_DEEMPH1_G0           0x320464
#define AUDIO_REG_DEEMPH1_A0           0x320468
#define AUDIO_REG_DEEMPH1_B0           0x32046C
#define AUDIO_REG_DEEMPH1_A1           0x320470
#define AUDIO_REG_DEEMPH1_B1           0x320474
#define AUDIO_REG_OUT0_SEL             0x320490
#define AUDIO_REG_OUT0_SHIFT           0x320494
#define AUDIO_REG_OUT1_SEL             0x320498
#define AUDIO_REG_OUT1_SHIFT           0x32049C
#define AUDIO_REG_RDSI_SEL             0x3204A0
#define AUDIO_REG_RDSI_SHIFT           0x3204A4
#define AUDIO_REG_RDSQ_SEL             0x3204A8
#define AUDIO_REG_RDSQ_SHIFT           0x3204AC
#define AUDIO_REG_DBX_IN_GAIN          0x320500
#define AUDIO_REG_DBX_WBE_GAIN         0x320504
#define AUDIO_REG_DBX_SE_GAIN          0x320508
#define AUDIO_REG_DBX_RMS_WBE          0x32050C
#define AUDIO_REG_DBX_RMS_SE           0x320510
#define AUDIO_REG_DBX_SE_BYPASS        0x320514
#define AUDIO_REG_FAWDETCTL            0x320530
#define AUDIO_REG_FAWDETWINCTL         0x320534
#define AUDIO_REG_DEEMPHGAIN_R         0x320538
#define AUDIO_REG_DEEMPHNUMER1_R       0x32053C
#define AUDIO_REG_DEEMPHNUMER2_R       0x320540
#define AUDIO_REG_DEEMPHDENOM1_R       0x320544
#define AUDIO_REG_DEEMPHDENOM2_R       0x320548
#define AUDIO_REG_ERRLOGPERIOD_R       0x32054C
#define AUDIO_REG_ERRINTRPTTHSHLD1_R   0x320550
#define AUDIO_REG_ERRINTRPTTHSHLD2_R   0x320554
#define AUDIO_REG_ERRINTRPTTHSHLD3_R   0x320558
#define AUDIO_REG_NICAM_STATUS1        0x32055C
#define AUDIO_REG_NICAM_STATUS2        0x320560
#define AUDIO_REG_ERRLOG1              0x320564
#define AUDIO_REG_ERRLOG2              0x320568
#define AUDIO_REG_ERRLOG3              0x32056C
#define AUDIO_REG_DAC_BYPASS_L         0x320580
#define AUDIO_REG_DAC_BYPASS_R         0x320584
#define AUDIO_REG_DAC_BYPASS_CTL       0x320588

#define AUDIO_REG_AUD_CTL              0x32058C
#define AUD_CTL_I2SIN_ENABLE           (1 << 15)
#define AUD_CTL_I2STODAC               (1 << 14)
#define AUD_CTL_I2SOUT_ENABLE          (1 << 13)
#define AUD_CTL_DAC_ENABLE             (1 << 12)
#define AUD_CTL_DEMATRIX_BYPASS        (1 << 11)
#define AUD_CTL_NICAM_TRY_AGAIN        (1 << 10)
#define AUD_CTL_FMRADIO_RDS            (1 << 9)
#define AUD_CTL_DEMATRIX               3, 7
#define AUD_DEMATRIX_SUM_DIFF          0
#define AUD_DEMATRIX_SUM_R             1
#define AUD_DEMATRIX_LR                2
#define AUD_DEMATRIX_MONO              3
#define AUD_CTL_NICAM_AUTO_FALLBACK    (1 << 6)
#define AUD_CTL_SRC_SEL                0x3F, 0
#define AUD_SRC_BTSC_FORCE_MONO        0
#define AUD_SRC_BTSC_FORCE_STEREO      1
#define AUD_SRC_BTSC_FORCE_SAP         2
#define AUD_SRC_BTSC_AUTO_STEREO       3
#define AUD_SRC_BTSC_AUTO_SAP          4
#define AUD_SRC_A2_FORCE_MONO1         8
#define AUD_SRC_A2_FORCE_MONO2         9
#define AUD_SRC_A2_FORCE_STEREO        10
#define AUD_SRC_A2_AUTO_MONO2          11
#define AUD_SRC_A2_AUTO_STEREO         12
#define AUD_SRC_EIAJ_FORCE_MONO1       16
#define AUD_SRC_EIAJ_FORCE_MONO2       17
#define AUD_SRC_EIAJ_FORCE_STEREO      18
#define AUD_SRC_EIAJ_AUTO_MONO2        19
#define AUD_SRC_EIAJ_AUTO_STEREO       20
#define AUD_SRC_FM_RADIO_FORCE_MONO    24
#define AUD_SRC_FM_RADIO_FORCE_STEREO  25
#define AUD_SRC_FM_RADIO_AUTO_STEREO   26
#define AUD_SRC_NICAM_FORCE_MONO1      32
#define AUD_SRC_NICAM_FORCE_MONO2      33
#define AUD_SRC_NICAM_FORCE_STEREO     34
#define AUD_SRC_NICAM_AUTO_MONO2       35
#define AUD_SRC_NICAM_AUTO_STEREO      36

#define AUDIO_REG_STATUS               0x320590
#define AUDIO_STATUS_MAIN_AFC          0x3FF, 6
#define AUDIO_STATUS_TIMEOUT           (1 << 4)
#define AUDIO_STATUS_PILOT             3, 2
#define AUDIO_PILOT_NONE               0
#define AUDIO_PILOT_C1                 1
#define AUDIO_PILOT_C2                 2
#define AUDIO_STATUS_STEREO_MODE       3, 0
#define AUDIO_STEREO_MODE_STEREO       0
#define AUDIO_STEREO_MODE_DUAL_MONO    1
#define AUDIO_STEREO_MODE_MONO         2
#define AUDIO_STEREO_MODE_SAP          3

#define AUDIO_REG_VOL_CTL              0x320594
#define VOL_CTL_DAC_MUTE               (1 << 8)
#define VOL_CTL_I2S_MUTE               (1 << 7)
#define VOL_CTL_SRC_MUTE               (1 << 6)
#define VOL_CTL_VOLUME                 0x3F, 0

#define AUDIO_REG_BAL_CTL              0x320598
#define BAL_CTL_RIGHT                  (1 << 6)
#define BAL_CTL_BALANCE                0x3F, 0

#define AUDIO_REG_START_TIMER          0x3205B0
#define AUDIO_REG_MODE_CHG_TIMER       0x3205B4
#define AUDIO_REG_POLYPH80SCALEFAC     0x3205B8
#define AUDIO_REG_DMD_RA_DDS           0x3205BC
#define AUDIO_REG_RATE_THRES_DMD       0x3205D0
#define AUDIO_REG_RATE_THRES_I2S       0x3205D4
#define AUDIO_REG_RATE_ADJ1            0x3205D8
#define AUDIO_REG_RATE_ADJ2            0x3205DC
#define AUDIO_REG_RATE_ADJ3            0x3205E0
#define AUDIO_REG_RATE_ADJ4            0x3205E4
#define AUDIO_REG_RATE_ADJ5            0x3205E8
 
#define AUDIO_REG_I2S_CTL              0x3205EC
#define I2S_CTL_PASSTHRU               (1 << 3)
#define I2S_CTL_SLAVE_INSCLK           (1 << 2)
#define I2S_CTL_OS_INSCLK              (1 << 1)
#define I2S_CTL_OS_OUTSCLK             (1 << 0)

#define AUDIO_REG_PHASE_FIX_CTL        0x3205F0
#define AUDIO_REG_PLL_PRESCALE         0x320600
#define AUDIO_REG_PLL_DDS              0x320604
#define AUDIO_REG_PLL_INT              0x320608
#define AUDIO_REG_PLL_FRAC             0x32060C
#define AUDIO_REG_PLL_JTAG             0x320620
#define AUDIO_REG_PLL_SPMP             0x320624

#define AUDIO_REG_AFE_12DB             0x320628

#define AUDIO_REG_PDF_DDS_CNST         0x320D00
#define AUDIO_REG_QAM_MODE             0x320D04
#define AUDIO_REG_PHACC_FREQ           0x320D28

#define AUDIO_REG_IN_GP_COUNT          0x32C020
#define AUDIO_REG_OUT_GP_COUNT         0x32C024

#define AUDIO_REG_IN_GP_COUNT_CONTROL  0x32C030
#define AUDIO_REG_OUT_GP_COUNT_CONTROL 0X32C034

#define AUDIO_REG_DMA_CONTROL          0x32C040
#define AUDIO_OUT_RISC_ENABLE          (1 << 5)
#define AUDIO_IN_RISC_ENABLE           (1 << 4)
#define AUDIO_OUT_FIFO_ENABLE          (1 << 1)
#define AUDIO_IN_FIFO_ENABLE           (1 << 0)

#define AUDIO_TRANSFER_STATUS          0x32C044
#define AUDIO_TRANSFER_IN_PROGRESS     (1 << 0)

#define AUDIO_REG_IN_LINE_LENGTH       0x32C048

#define AUDIO_REG_INT_MASK             0x200060
#define AUDIO_REG_INT_STAT             0x200064
#define AUDIO_REG_INT_MSTAT            0x200068
#define AUDIO_REG_INT_SSTAT            0x20006C
#define AUDIO_INT_MODE_CHANGE          (1 << 21)
#define AUDIO_INT_BER                  (1 << 20)
#define AUDIO_INT_PCI_ABORT            (1 << 19)
#define AUDIO_INT_RIP_ERR              (1 << 18)
#define AUDIO_INT_PAR_ERR              (1 << 17)
#define AUDIO_INT_OPCODE_ERR           (1 << 16)
#define AUDIO_INT_OUT_SYNC             (1 << 13)
#define AUDIO_INT_IN_SYNC              (1 << 12)
#define AUDIO_INT_OUT_UNDERFLOW        (1 << 9)
#define AUDIO_INT_IN_OVERFLOW          (1 << 8)
#define AUDIO_INT_OUT_RISCI2           (1 << 5)
#define AUDIO_INT_IN_RISCI2            (1 << 4)
#define AUDIO_INT_OUT_RISCI1           (1 << 1)
#define AUDIO_INT_IN_RISCI1            (1 << 0)

#endif
