#ifndef __CX88_MPEGPS_FILTER_H__
#define __CX88_MPEGPS_FILTER_H__

#include "cx88_capture.h"

#ifndef _DVBPSI_DVBPSI_H_
#include <dvbpsi.h>
#endif

#ifndef _DVBPSI_DESCRIPTOR_H_
#include <descriptor.h>
#endif

#ifndef _DVBPSI_PSI_H_
#include <psi.h>
#endif

#ifndef _DVBPSI_PAT_H_
#include <pat.h>
#endif

#ifndef _DVBPSI_PMT_H_
#include <pmt.h>
#endif

class cx88_mpegps_filter
   : public cx88_capture
{
   public:
      
      cx88_mpegps_filter(capvec &captures, int &error);
      
      virtual ~cx88_mpegps_filter(void) {}
   
      void select_stream(uint16_t stream)
      {
         m_stream = stream;
         m_pids.clear();
      }
      
   protected:
      
      virtual void process_buffer(void *data, size_t num_bytes, size_t packet_size = 0);
      
      virtual int initialize(void);
      
      virtual void flush(void);
      
   private:
      
      capvec &m_captures;
      uint16_t m_stream;
      vector<uint16_t> m_pids;
      dvbpsi_handle m_handle;
      enum
      {
         CX88_MPEGPS_IDLE,
         CX88_MPEGPS_STARTED,
         CX88_MPEGPS_PAT_FOUND,
         CX88_MPEGPS_PMT_FOUND
      } m_state;
      
      static void pat_complete(void *context, dvbpsi_pat_t *pat);
      
      static void pmt_complete(void *context, dvbpsi_pmt_t *pmt);
};

#endif
